#!/usr/bin/perl

#$datadir = "./";
$epnfile = "./epn.dat";
$erpinexec = "./erpin64";
$datadir = "./Data/";
#$epnfile = "rfam8.1.dat";
#$datadir = "/home/daniel/Erpin/BATCH/LOCALSETS/";
#$epnfile = "local.dat";
$dbfile = $ARGV[0];
$domain = $ARGV[1];

$max_evalue= 10;  #E-value limit (10Mb)
$max_cpu= 30;  #CPU limit in seconds /100kb

if ($#ARGV < 1) {
    print "epnscan.pl <Fasta sequence file> <Domain> \n";
    print "Domain is: BAC, ARC, EUK, VIR, ALL\n";
    exit;
}

if (!open(F,  $epnfile)) {
    print STDERR "Can't open $epnfile\n";
    exit;
}

$x = `date`;
print $x;

while (($line = <F>)) {
    ($fname, $dom, $def, $ev, $cpu, $comm) = split ("//", $line);
    chomp $comm;

    if ($fname !~/^#/) {
	$i=0;
	$tothits=0;
	$totfamilies=0;

	if ($cpu =~ /(\d+)h/) {
	    $hour=$1;
	}else{
	    $hour=0;
	}
	
	if ($cpu =~ /(\d+)m/) {
	    $min=$1;
	}else{
	    $min=0;
	}
	
	if ($cpu =~ /([\d\.]+)sec/) {
	    $sec=$1;
	}else{
	    $sec=0;
	}
	$cpu2=$hour*3600 + $min*60.0 + $sec;

	if ((($domain =~ /ALL/i)||($dom =~ /$domain/g)) && ($ev < $max_evalue)&& ($cpu2 < $max_cpu)) {
	    if ($comm ne "") {
		$cmd = "$erpinexec $datadir$fname $dbfile $comm -chrono";
		print $def,"\n";
		print $cmd,"\n";
		$out = `$cmd`;
		if ($out =~ /(\d+)\s+independent hit/g) {
		    $nbhits = $1;
		    $totfamilies++;
		    print $out;
		}else{
		    @lines = split ("\n", $out);
		    $lastline = pop (@lines);
		    print "\n", $lastline, "\n";
		}
		$tothits+=$nbhits;
	    }
	}
    }
}

print "$tothits hits from $totfamilies families\n";

$x = `date`;
print $x;


